---
title: ServiceWorkerMessageEvent.lastEventId
slug: Web/API/ServiceWorkerMessageEvent/lastEventId
tags:
  - API
  - Deprecated
  - Experimental
  - Property
  - Reference
  - Service Workers
  - ServiceWorkerMessageEvent
  - lastEventID
---
<p>{{APIRef("Service Workers API")}}{{deprecated_header}}</p>

<div class="warning">
<p><strong>Important</strong>: In modern browsers, this property has been deprecated. Service worker messages will now use the {{domxref("MessageEvent")}} interface, for consistency with other web messaging features.</p>
</div>

<p>The <strong><code>lastEventID</code></strong> read-only property of the {{domxref("ServiceWorkerMessageEvent")}} interface represents, in <a href="/en-US/docs/Web/API/en-US/docs/Server-sent_events/Using_server-sent_events">server-sent events</a>, the last event ID of the event source.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var myLastEventId = ServiceWorkerMessageEventInstance.lastEventId;</pre>

<h3 id="Value">Value</h3>

<p>A {{domxref("DOMString")}}.</p>

<h2 id="Examples">Examples</h2>

<p>When the following code is used inside the main thread to set up a message channel between it and a service worker for sending messages between the two, the event object of <code>onmessage</code> will be a <code>ServiceWorkerMessageEvent</code>.</p>

<pre class="brush: js">navigator.serviceWorker.ready.then(function(reg) {

  ...

      // set up a message channel to communicate with the SW
      var channel = new MessageChannel();
      channel.port1.onmessage = function(e) {
        console.log(e.lastEventId);
        handleChannelMessage(e.data);
      }

      mySW = reg.active;
      mySW.postMessage('hello', [channel.port2]);
  });</pre>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.ServiceWorkerMessageEvent.lastEventId")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/ServiceWorker_API/Using_Service_Workers">Using Service Workers</a></li>
 <li><a class="external external-icon" href="https://github.com/mdn/sw-test">Service workers basic code example</a></li>
 <li><a class="external external-icon" href="https://jakearchibald.github.io/isserviceworkerready/">Is ServiceWorker ready?</a></li>
 <li><a href="/en-US/docs/Web/API/Channel_Messaging_API">Channel Messaging</a></li>
</ul>
